Skip to main content

Bit Manipulation - Medium Level

 Leetcode 416 Partition Equal Subset Sum

Given a non-empty array nums containing only positive integers, find if the array can be partitioned into two subsets such that the sum of elements in both subsets is equal.

Constraints:

1 <= nums.length <= 200

1 <= nums[i] <= 100


Analysis:


There are different ways to solve this problem, such as dp with a time complexity of O(N^2).

Since N is small to this question, so it is Okay to pass OJ.

Besides the small N, the value of each element is also very small. So this gives us some chance to use "space to trad off time".

The data structure to be used is bitset. For bitset, each bit can be either 0 or 1. The index of that bit can be used as the corresponding sum. When the bit is 1, means there is a sum with the value of its index.

When a new number comes, this number needs to be added to all the previous sums, to form new "previous" sums. Thus for each number, we need to go through all the previous sums, the time complexity of which is O(N^2) in average. There are N numbers, so the overall time complexity is O(N^3).

With a bitset, for each number, we just need to use the shift operator (<< and >>) and the or (|) operator directly, without go through all the previous sums. The time complexity is from O(N^2) to O(1). Here is how it works:

1. All the previous sums are stored in the bitset (the index of 1's);

2. When a new number is taken into account, we just need to shift the bitset to the left by the value of the number (let say X). Then all the 1's will be shifted left by X bits, so all the previous sums are updated by adding X with this one time operation!

3. We still need to keep the previous sums before the update in 2. And or (|) operation between the bitset before the update and that after the update would perfectly solve this problem.

After scanning to the last number, we just need to check

1. the overall sum is even or not; if odd, return false directly

2. if even, we just need to check the bit value of the bit at the index of (total sum)/2 in the bitset. If 1, return true; o/w, return false.


See the code below:


class Solution {
public:
    bool canPartition(vector<int>& nums) {
        int sum = 0;
        bitset<20001> bt(1); // bt[0] is 1
        for(auto &a : nums) {
            sum += a;
            bt |= bt << a;
        }
        return !(sum & 1) && bt[sum >> 1];
    }
};


Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...